{
   [big_fury]
   888888888     8888   888888888888   8888       888888888      8888      8888     888888888   
 8888888888888   8888   888888888888   8888     8888888888888    8888      8888   8888888888888
 8888     8888                88888            8888       8888   8888      8888   8888     8888 
 888888888       8888       888888     8888   8888         8888  8888      8888   888888888     
   8888888888    8888      88888       8888   8888         8888  8888      8888     88888888888 
        888888   8888    88888         8888   8888         8888  8888      8888           888888
 8888      8888  8888   88888          8888    8888       8888   8888      8888   8888      8888
 8888888888888   8888  88888888888888  8888     8888888888888     888888888888    8888888888888 
   8888888888    8888  88888888888888  8888       888888888        8888888888       8888888888  

  Unit JavaClk
  =============

  Description : Unit permettant de cliquer sur un bouton gnrant du JavaScript. Vous devez
		            utiliser un TWebBrowser pour cette opration. Vous pouvez, si vous le souhaitez,
		            cliquer sur n'importe quel bouton du TWebBrowser.

  Procdures  : - ClickOnWebButton    : Cette fonction est la fonction principale qui clique
                                        sur le bouton gnrant du JavaScript. Vous devez passer
					                              comme paramtre le WebBrowser  utiliser, l'URL que vous
					                              voulez et galement si vous souhaitez dsactiver le son
					                              de notification lorsque vous cliquez sur un bouton (il est
                                        rtabli ensuite). Elle renvoie True si tout c'est bien pass.

                                        Remarque : Deux variantes existent : Soit vous donnez le nom
                                        du bouton tel qu'il apparait dans le code source de la page
                                        web (son ID, quoi).
                                        Sinon, autre option, vous rentrez sa Caption.
                                        Si vous souhaitez faire comme cela, faire la modification
                                        dans la fonction  l'endroit indiqu par JROD.

                - SetNavigationSound  : Utilise par ClickOnWebButton, cette fonction change le son
					                              de notification de navigation par celui que vous voulez.
					                              Vous devez passer comme paramtre le chemin du fichier
                                         utiliser, et galement spcifier si vous souhaitez crer
                                        la clef si elle n'existe pas.

					                              Remarque : Si vous spcifiez comme nom la chaine vide aucun son
					                              ne sera jou lors de la navigation.

                - GetNavigationSound  : Cette fonction en lecture seule permet d'avoir le nom
                                        du fichier utilis actuellement pour signaler la navigation.



  Auteur      : JROD (fonction principale) et [big_fury]SiZiOUS (pour les 2
                fonctions grant le son de navigation).

  E-mail      : sizious[NO-SPAM]@yahoo.fr

  URL         : http://sbibuilder.shorturl.com/ ou http://www.sbibuilder.fr.st/

  Remarques   : Un TRES GRAND merci  JROD pour son aide.
		            La discution est disponible ici :
		            http://www.phidels.com/php/index.php3?page=forum/index.php3

                Un grand merci  lui, galement  tout le monde de Phidels.com.

  TO DO       : La fonction ne fonctionne pas  tous les coups (notamment si vous
                appellez cette fonction trop de fois d'affil). Il reste donc 
                faire de l'optimisation, mais l'essentiel est l.
}

unit javaclk;

interface

uses
  Windows, Forms, Registry, SHDocVw, MSHTML_TLB;

function ClickOnWebButton(WebBrowser : TWebBrowser ; URL,
                          ButtonID : string ;
                          DisableClickSound : boolean) : boolean;
function SetNavigationSound(SoundFile : string ; CreateKey : boolean = False) : boolean;
function GetNavigationSound : string;

implementation

{ 
  Mettre MSHTML_TLB et SHDocVw_TLB dans les uses (Delphi4)
  Mettre SHDocVw, MSHTML_TLB pour Delphi6+
  Si vous n'avez pas MSHTML_TLB, il faudra importer la librairie : Microsoft HTML Object Library
  Si vous n'avez pas SHDocVw_TLB, il faudra importer la librairie : Microsoft Internet Controls
  Si vous ne savez pas le faire rendez-vous sur le forum.
}

//---ClickOnWebButton---
//Fonction cliquant sur le bouton du WebBrowser. Code de JROD.
function ClickOnWebButton(WebBrowser : TWebBrowser ; URL,
                          ButtonID : string ;
                          DisableClickSound : boolean) : boolean;
var
  doc         : ihtmldocument2;
  Collection  : IHTMLElementCollection;
  IDP         : IDispatch;
  i           : integer;
  InputButton : HTMLInputButtonElement;
  SoundFile   : string; //pour enlever les "clicks" lis au navigateur.
  
begin
  Result := False;
  SoundFile := GetNavigationSound;
                                     
  try
    if DisableClickSound then
      SetNavigationSound(''); //dsactive le son.

    //WebBrowser1.Navigate(WideString('http://www.google.com'),o,o,o,o); {Delphi 4}
    WebBrowser.Navigate(URL); {Delphi 6+}

    //Attendre la fin du chargement de la page. TRES MAUVAISE BOUCLE.
    while WebBrowser.Busy do
      Application.ProcessMessages;

    //showmessage('attendez la fin de chargement de la page avant de continuer');

    doc := (WebBrowser.document as ihtmldocument2);

    if Assigned(doc) then
    begin

      IDP := Doc.all.tags('input');
      if Assigned(IDP) then
      begin
        IDP.QueryInterface(IHTMLElementCollection, Collection);

        if Assigned(Collection) then
        begin

          for i := 1 to Collection.Get_length do
          begin
            IDP:= Collection.item(pred(i), 0);
            IDP.QueryInterface(HTMLInputButtonElement{HTMLInputImage}, InputButton);

            if Assigned(InputButton) then
            begin

              { CHANGEZ ICI : Il y'a 2 possibilits d'appel.
                Name fait rfrence  l'ID du bouton dans le code source de la page Web.
                Value, c'est sa caption. }
              if  InputButton.Name = ButtonID then {InputButton.Value = ButtonID}
              begin
                //showmessage('le bouton a t trouv, on va cliquer dessus');
                Result := True;
                InputButton.Click;
              end;

            end;

          end;

        end;

      end;

    end;

    //a la fin activer le son,
    if DisableClickSound then
      SetNavigationSound(SoundFile);
      
  except
    //si exception on active quand mme
    if DisableClickSound then
      SetNavigationSound(SoundFile); //active le son.
    Result := False;
  end;
end;

{ Registry Settings
User Key: [HKEY_CURRENT_USER\AppEvents\Schemes\Apps\Explorer\Navigating\.current]
Value Name: (Default)
Data Type: REG_SZ (String Value)
Value Data: Sound Filename (Empty for no sound) }

//---SetNavigationSound---
//Modifier la valeur du son lors du "click" du navigateur.
function SetNavigationSound(SoundFile : string ; CreateKey : boolean = False) : boolean;
var
  RG : TRegistry;

begin
  Result := False;

  RG := TRegistry.Create;
  try
    RG.RootKey := HKEY_CURRENT_USER;

    //On peut crer la clef si le mec le veut.
    if RG.OpenKey('AppEvents\Schemes\Apps\Explorer\Navigating\.current', CreateKey) then
    begin
      Result := True;
      RG.WriteString('', SoundFile);
    end;

  finally
    RG.Free;
  end;

end;

//---GetNavigationSound---
//Avoir le fichier son qui joue lors des "clicks" du navigateur.
function GetNavigationSound : string;
var
  RG : TRegistry;

begin
  Result := '';

  RG := TRegistry.Create;
  try
    RG.RootKey := HKEY_CURRENT_USER;

    if RG.OpenKey('AppEvents\Schemes\Apps\Explorer\Navigating\.current', False) then
      Result := RG.ReadString('');

  finally
    RG.Free;
  end;

end;

end.
